<template>
  <transition name="fly">
    <div class="nav-menu" v-if="navMenuOpened" :class="themeClasses">
      <button
        @click="closeNavMenu()"
        class="close-button"
        :class="themeClasses"
      >
        close
      </button>
      <div class="menu-content">
        <h1 class="menu-title menu-section-container">
          {{ $t("navMenu.title") }}
        </h1>

        <div class="menu-section">
          <div class="menu-groups-wrapper menu-section-container">
            <ul class="menu-groups">
              <li
                class="menu-group"
                :class="themeClasses"
                v-for="group in groups"
                v-bind:key="group.groupId"
              >
                <a
                  @click.prevent="switchGroup(group.groupId)"
                  v-bind:href="`/groups/${group.groupId}`"
                  >{{ $t(`group.${group.groupId}`) }}</a
                >
              </li>
            </ul>
            <span class="group-actived-bar" :style="activedBarStyle"></span>
          </div>
        </div>

        <div class="menu-section">
          <div class="menu-section-container">
            <a class="skm-home-page" href="https://www.skm.com.tw">{{
              $t("navMenu.skmHomePage")
            }}</a>
          </div>
        </div>

        <div class="menu-section">
          <div class="menu-section-container">
            <ul class="locale-selector">
              <li
                v-for="locale in locales"
                v-bind:key="locale"
                class="locale-option"
              >
                <button @click="setLocale(locale)">
                  {{ $t(`nav.languages.${locale}`) }}
                </button>
              </li>
            </ul>
          </div>
        </div>
      </div>
    </div>
  </transition>
</template>

<script>
import { mapState, mapGetters, mapActions } from "vuex";

export default {
  computed: {
    ...mapState(["navMenuOpened", "locales"]),
    ...mapState("groups", ["groups"]),
    ...mapState("group", ["group"]),
    ...mapGetters("theme", ["themeClasses"]),

    activedGroupIndex() {
      if (!this.group) {
        return -1;
      }
      for (let i = 0; i < this.groups.length; i += 1) {
        let group = this.groups[i];
        if (group.groupId === this.group.id) {
          return i;
        }
      }
      return -1;
    },

    activedBarStyle() {
      return {
        top: `${
          this.activedGroupIndex !== -1 ? this.activedGroupIndex * 52 : -52
        }px`,
        opacity: this.activedGroupIndex !== -1 ? 1 : 0
      };
    }
  },

  methods: {
    ...mapActions(["openNavMenu", "closeNavMenu", "setLocale"]),
    ...mapActions("groups", ["loadGroups"]),
    ...mapActions("group", ["updateFilter"]),

    switchGroup(groupId) {
      this.$router.push(`/groups/${groupId}`);
      this.updateFilter({ groupId });
      this.closeNavMenu();
    }
  },

  mounted() {
    this.loadGroups();
  }
};
</script>

<style lang="scss" scoped>
.menu-section {
  border-bottom: 1px $color-white solid;
  overflow: hidden;

  &:last-child {
    border-bottom: none;
  }
}

.nav-menu {
  position: fixed;
  width: 100%;
  height: 100%;
  left: 0;
  top: 0;
  z-index: 1001;
  color: $color-white;
  overflow-y: scroll;

  &:before {
    content: "";
    background-color: $color-large-bg-red;
    position: fixed;
    z-index: -1;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    opacity: 0.95;
  }

  a {
    color: $color-white;
  }

  &.theme-vip-member {
    &:before {
      background-color: $color-gold-300;
    }
  }
}

.menu-content {
  display: block;
  width: 300px;
  margin: 20px auto;
}

.menu-title {
  font-size: 16px;
  font-weight: normal;
  line-height: 72px;
  padding-left: 60px;
  box-sizing: border-box;
}

.menu-groups-wrapper {
  position: relative;
  padding-left: 30px;
}

.menu-groups {
  margin: 0;
  padding: 0;
  list-style: none;
  width: 100%;
  margin-bottom: 20px;
}

.menu-group {
  line-height: 52px;
  padding-left: 30px;
  box-sizing: border-box;
  width: 100%;
  border-left: 1px $color-very-dark-red solid;

  &.theme-vip-member {
    border-color: $color-skm-gold;
  }
}

.group-actived-bar {
  position: absolute;
  left: 30px;
  width: 1px;
  background: $color-white;
  height: 52px;
  transition: all 0.2s;
}

.skm-home-page {
  display: inline-block;
  line-height: 72px;
  width: 100%;
  text-align: center;
}

.menu-section-container {
  width: 200px;
  margin-left: auto;
  margin-right: auto;
}

.locale-selector {
  list-style: none;
  margin: 0;
  padding: 0;
  line-height: 72px;
  text-align: center;
}

.locale-option {
  display: inline-block;
}

.locale-option button {
  background: none;
  border: none;
  color: $color-white;
  cursor: pointer;
}

.close-button {
  position: absolute;
  top: 10px;
  left: 10px;
  text-indent: -9999px;
  overflow: hidden;
  background: $color-dark-red;
  width: 32px;
  height: 32px;
  border-radius: 2px;
  border: none;
  padding: 0;
  cursor: pointer;

  &:before,
  &:after {
    content: "";
    position: absolute;
    left: 30%;
    top: 50%;
    background: $color-white;
    height: 2px;
    border-radius: 1px;
    width: 40%;
    margin-top: -1px;
  }

  &:before {
    transform: rotateZ(45deg);
  }

  &:after {
    transform: rotateZ(-45deg);
  }

  &.theme-vip-member {
    background: rgba($color-skm-gold, 0.3);
  }
}

.fly-enter-active,
.fly-leave-active {
  transition: all 0.2s;
}

.fly-enter,
.fly-leave-to {
  opacity: 0;
  transform: translateX(-100%);
}
</style>
